//+------------------------------------------------------------------+
//|   .mq4 |
//| Copyright  2010, MetaQuotes Software Corp. |
//| http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link "http://www.metaquotes.net"

extern int BandsPeriod=20,
           i=1 ;
extern int BandsShift=0;
extern double BandsDeviations=2.0;
extern double Lots=0.1,
              TakeProfit=50,
              StopLoss=10 ;
string comment="macd sample";

//+------------------------------------------------------------------+
//| expert initialization function |
//+------------------------------------------------------------------+
int init() {return(0);}

//+------------------------------------------------------------------+
//| expert deinitialization function |
//+------------------------------------------------------------------+
int deinit()
{
//----

//----
return(0);
}
//+------------------------------------------------------------------+
//| expert start function |
//+------------------------------------------------------------------+
int start() {
   double Average,
          Verhnyayaghranytsa,
          Nyzhnyayaghranytsa,
          newres,
          sum,
          deviation;

   Average=iMA(NULL,0,BandsPeriod,BandsShift,MODE_SMA,PRICE_CLOSE,i);
   
   newres=Close[i]-Average;
   sum=newres*newres;


   deviation=BandsDeviations*MathSqrt(sum/BandsPeriod);
   Verhnyayaghranytsa=Average+deviation;
   Nyzhnyayaghranytsa=Average-deviation;

   
   if (Verhnyayaghranytsa<Close[i]){ 
      Comment(" ! ",Verhnyayaghranytsa ); 
//      OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Bid-StopLoss*Point,Ask+TakeProfit*Point,"macd sample",16384,0,Green);
      Order_Send(Symbol(), 16384, OP_BUY);
   } 


   if (Nyzhnyayaghranytsa>Close[i]){ 
      Comment(" ! ",Nyzhnyayaghranytsa );
//      OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Ask+stoploss*Point,Bid-TakeProfit*Point,"macd sample",16384,0,Red);
      Order_Send(Symbol(), 16384, OP_SELL);
   }
   return(0);
}
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//|                          |
//|                             (   , |
//|                                        ) |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
//| void Order_Open_Next(int lMagic, int lOP);                       |
//+------------------------------------------------------------------+
void Order_Send(string lSymbol, int lMagic, int lOP){
   int err=GetLastError();
   RefreshRates();
   int cmd=0;

   double _ask       = MarketInfo(lSymbol,MODE_ASK);
   double _bid       = MarketInfo(lSymbol,MODE_BID);
   double _point     = MarketInfo(lSymbol,MODE_POINT);
   double _digits    = MarketInfo(lSymbol,MODE_DIGITS);
   double _stoplevel = MarketInfo(lSymbol,MODE_STOPLEVEL);
   double _spred=(_ask-_bid)/_point;
   double price;
   if (lOP==OP_BUY)  {
      cmd=1;
      price=_ask;
   }
   if (lOP==OP_SELL) {
      cmd=-1;
      price=_bid;   
   }
   double _tp=0;
   if (TakeProfit>0) {
      _tp=NormalizeDouble(price+cmd*TakeProfit*_point,_digits);
      if (_stoplevel > TakeProfit)
         _tp=NormalizeDouble(price+cmd*_stoplevel*_point,_digits);
   }
   double _sl=0;
   if (StopLoss>0) {
      _sl=NormalizeDouble(price-cmd*StopLoss*_point,_digits);
      if (_stoplevel > StopLoss)
         _sl=NormalizeDouble(price-cmd*_stoplevel*_point,_digits);
   }
   if (OrderSend(Symbol(), lOP,  Lots, price, _spred, _sl,_tp,comment,lMagic, 0)==-1) { 
      err=GetLastError();
      Print(fMyErDesc(err));
   }
}


//+------------------------------------------------------------------+
//|                                             |
//|                                        Copyright  2010, Integer |
//+------------------------------------------------------------------+
//| string fMyErDesc(int aErrNum);                                   |
//+------------------------------------------------------------------+

string fMyErDesc(int aErrNum){
   string pref="Err Num: "+aErrNum+" - ";
   switch(aErrNum){
      case    0: return(pref+"NO ERROR"                              );
      case    1: return(pref+"NO RESULT"                             );
      case    2: return(pref+"COMMON ERROR"                          );
      case    3: return(pref+"INVALID TRADE PARAMETERS"              );
      case    4: return(pref+"SERVER BUSY"                           );
      case    5: return(pref+"OLD VERSION"                           );
      case    6: return(pref+"NO CONNECTION"                         );
      case    7: return(pref+"NOT ENOUGH RIGHTS"                     );
      case    8: return(pref+"TOO FREQUENT REQUESTS"                 );
      case    9: return(pref+"MALFUNCTIONAL TRADE"                   );
      case   64: return(pref+"ACCOUNT DISABLED"                      );
      case   65: return(pref+"INVALID ACCOUNT"                       );
      case  128: return(pref+"TRADE TIMEOUT"                         );
      case  129: return(pref+"INVALID PRICE"                         );
      case  130: return(pref+"INVALID STOPS"                         );                           
      case  131: return(pref+"INVALID TRADE VOLUME"                  );
      case  132: return(pref+"MARKET CLOSED"                         );
      case  133: return(pref+"TRADE DISABLED"                        );
      case  134: return(pref+"NOT ENOUGH MONEY"                      );
      case  135: return(pref+"PRICE CHANGED"                         );
      case  136: return(pref+"OFF QUOTES"                            );
      case  137: return(pref+"BROKER BUSY"                           );
      case  138: return(pref+"REQUOTE"                               );
      case  139: return(pref+"ORDER LOCKED"                          );
      case  140: return(pref+"LONG POSITIONS ONLY ALLOWED"           );
      case  141: return(pref+"TOO MANY REQUESTS"                     );
      case  145: return(pref+"TRADE MODIFY DENIED"                   );
      case  146: return(pref+"TRADE CONTEXT BUSY"                    );
      case  147: return(pref+"TRADE EXPIRATION DENIED"               );
      case  148: return(pref+"TRADE TOO MANY ORDERS"                 );
      //---- mql4 run time errors
      case 4000: return(pref+"NO MQLERROR"                           );
      case 4001: return(pref+"WRONG FUNCTION POINTER"                );
      case 4002: return(pref+"ARRAY INDEX OUT OF RANGE"              );
      case 4003: return(pref+"NO MEMORY FOR FUNCTION CALL STACK"     );
      case 4004: return(pref+"RECURSIVE STACK OVERFLOW"              );
      case 4005: return(pref+"NOT ENOUGH STACK FOR PARAMETER"        );
      case 4006: return(pref+"NO MEMORY FOR PARAMETER STRING"        );
      case 4007: return(pref+"NO MEMORY FOR TEMP STRING"             );
      case 4008: return(pref+"NOT INITIALIZED STRING"                );
      case 4009: return(pref+"NOT INITIALIZED ARRAYSTRING"           );
      case 4010: return(pref+"NO MEMORY FOR ARRAYSTRING"             );
      case 4011: return(pref+"TOO LONG STRING"                       );
      case 4012: return(pref+"REMAINDER FROM ZERO DIVIDE"            );
      case 4013: return(pref+"ZERO DIVIDE"                           );
      case 4014: return(pref+"UNKNOWN COMMAND"                       );
      case 4015: return(pref+"WRONG JUMP"                            );
      case 4016: return(pref+"NOT INITIALIZED ARRAY"                 );
      case 4017: return(pref+"DLL CALLS NOT ALLOWED"                 );
      case 4018: return(pref+"CANNOT LOAD LIBRARY"                   );
      case 4019: return(pref+"CANNOT CALL FUNCTION"                  );
      case 4020: return(pref+"EXTERNAL EXPERT CALLS NOT ALLOWED"     );
      case 4021: return(pref+"NOT ENOUGH MEMORY FOR RETURNED STRING" );  
      case 4022: return(pref+"SYSTEM BUSY"                           );                            
      case 4050: return(pref+"INVALID FUNCTION PARAMETERS COUNT"     );
      case 4051: return(pref+"INVALID FUNCTION PARAMETER VALUE"      );
      case 4052: return(pref+"STRING FUNCTION INTERNAL ERROR"        );
      case 4053: return(pref+"SOME ARRAY ERROR"                      ); 
      case 4054: return(pref+"INCORRECT SERIES ARRAY USING"          ); 
      case 4055: return(pref+"CUSTOM INDICATOR ERROR"                );
      case 4056: return(pref+"INCOMPATIBLE ARRAYS"                   );
      case 4057: return(pref+"GLOBAL VARIABLES PROCESSING ERROR"     );
      case 4058: return(pref+"GLOBAL VARIABLE NOT FOUND"             ); 
      case 4059: return(pref+"FUNCTION NOT ALLOWED IN TESTING MODE"  );
      case 4060: return(pref+"FUNCTION NOT CONFIRMED"                );
      case 4061: return(pref+"SEND MAIL ERROR"                       );
      case 4062: return(pref+"STRING PARAMETER EXPECTED"             );
      case 4063: return(pref+"INTEGER PARAMETER EXPECTED"            );
      case 4064: return(pref+"DOUBLE PARAMETER EXPECTED"             );
      case 4065: return(pref+"ARRAY AS PARAMETER EXPECTED"           );
      case 4066: return(pref+"HISTORY WILL UPDATED"                  );
      case 4067: return(pref+"TRADE ERROR"                           );
      case 4099: return(pref+"END OF FILE"                           );
      case 4100: return(pref+"SOME FILE ERROR"                       );
      case 4101: return(pref+"WRONG FILE NAME"                       );
      case 4102: return(pref+"TOO MANY OPENED FILES"                 );
      case 4103: return(pref+"CANNOT OPEN FILE"                      );
      case 4104: return(pref+"INCOMPATIBLE ACCESS TO FILE"           );
      case 4105: return(pref+"NO ORDER SELECTED"                     );
      case 4106: return(pref+"UNKNOWN SYMBOL"                        );
      case 4107: return(pref+"INVALID PRICE PARAM"                   );
      case 4108: return(pref+"INVALID TICKET"                        );
      case 4109: return(pref+"TRADE NOT ALLOWED"                     );
      case 4110: return(pref+"LONGS  NOT ALLOWED"                    );
      case 4111: return(pref+"SHORTS NOT ALLOWED"                    );
      case 4200: return(pref+"OBJECT ALREADY EXISTS"                 );
      case 4201: return(pref+"UNKNOWN OBJECT PROPERTY"               );
      case 4202: return(pref+"OBJECT DOES NOT EXIST"                 );
      case 4203: return(pref+"UNKNOWN OBJECT TYPE"                   );
      case 4204: return(pref+"NO OBJECT NAME"                        );
      case 4205: return(pref+"OBJECT COORDINATES ERROR"              );
      case 4206: return(pref+"NO SPECIFIED SUBWINDOW"                );
      case 4207: return(pref+"SOME OBJECT ERROR"                     );      
      
      default:   return(pref+"WRONG ERR NUM"                         );
   }
}  

